//+------------------------------------------------------------------+
//|                                                                  |
//|                                                          SOK.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

// ---- input parameters ----
extern string  pop_roh  = "0=vavohore, 1=vpravohore, 2=vavodole, 3=vpravodole";
extern int     roh      = 1;
extern color   Popis    = Yellow;
extern color   Plus     = Green;
extern color   Minus    = Red;
extern color   Hodnota  = White;
extern string  pop_Mini = "true pre m et, inak false";
extern bool    Mini     = true;
extern int     font     = 14;

double MaxHEG = -10000;
double MinLEG = 10000;
double MaxHEU = -10000;
double MinLEU = 10000;
double MaxHGU = -10000;
double MinLGU = 10000;
double MaxHEJ = -10000;
double MinLEJ = 10000;

double MaxHUJ = -10000;
double MinLUJ = 10000;
double MaxHGJ = -10000;
double MinLGJ = 10000;

// ---- global variable ----
double Usdjpy, Gbpusd,Gbpjpy,Eurusd,Eurgbp,Eurjpy ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if (Mini == true)
   {
      Gbpjpy = MarketInfo("GBPJPYm",MODE_BID);
      Usdjpy = MarketInfo("USDJPYm",MODE_BID);
      Gbpusd = MarketInfo("GBPUSDm",MODE_BID);
      Eurjpy = MarketInfo("EURJPYm",MODE_BID);
      Eurusd = MarketInfo("EURUSDm",MODE_BID);
      
      
   }
   
   
   
   else
   {
      Gbpjpy = MarketInfo("GBPJPY",MODE_BID);
      Usdjpy = MarketInfo("USDJPY",MODE_BID);
      Gbpusd = MarketInfo("GBPUSD",MODE_BID);
      Eurjpy = MarketInfo("EURJPY",MODE_BID);
      Eurusd = MarketInfo("EURUSD",MODE_BID);
     
   }

   return(0);
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   for(int i = ObjectsTotal() - 1; i>=0; i--)
   {
      string label = ObjectName(i);
      if (StringSubstr (label, 0, 3) != "MPS")
         continue;
      ObjectDelete (label);
   }
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   
   if (Mini == true)
   {
      Gbpjpy = MarketInfo("GBPJPYm",MODE_BID);
      Usdjpy = MarketInfo("USDJPYm",MODE_BID);
      Gbpusd = MarketInfo("GBPUSDm",MODE_BID);
      Eurjpy = MarketInfo("EURJPYm",MODE_BID);
      Eurusd = MarketInfo("EURUSDm",MODE_BID);
      Eurgbp = MarketInfo("EURGBPm",MODE_BID);
      }
   else
   {
      Gbpjpy = MarketInfo("GBPJPY",MODE_BID);
      Usdjpy = MarketInfo("USDJPY",MODE_BID);
      Gbpusd = MarketInfo("GBPUSD",MODE_BID);
      Eurjpy = MarketInfo("EURJPY",MODE_BID);
      Eurusd = MarketInfo("EURUSD",MODE_BID);
      Eurgbp = MarketInfo("EURGBP",MODE_BID);
   }
   
   double c1=Gbpjpy;
   double c2=Usdjpy;
   double c3=Gbpusd;
   double c4=Eurjpy;
   double c5=Eurusd;
   double c6=Eurgbp;
   
   
   double LevelGJ1 =((c2*c3)-c1); 
   double LevelEJ1 =((c2*c5)-c4); 
   double LevelGU1 =((c1/c2)-c3); 
   double LevelEU1 =((c4/c2)-c5);
   double LevelUJ1 =((c4/c5)-c2);
   double LevelEG1 =((c5/c3)-c6);
    
   double LevelGJ2 =((c4/c6)-c1); 
   double LevelEJ2 =((c1*c6)-c4); 
   double LevelGU2 =((c5/c6)-c3); 
   double LevelEU2 =((c3*c6)-c5);
   double LevelUJ2 =((c1/c3)-c2);
   double LevelEG2 =((c4/c1)-c6);
   
    
   double LevelGJ =(LevelGJ1+LevelGJ2)*100; 
   double LevelEJ =(LevelEJ1+LevelEJ2)*100; 
   double LevelGU =(LevelGU1+LevelGU2)*10000; 
   double LevelEU =(LevelEU1+LevelEU2)*10000;
   double LevelUJ =(LevelUJ1+LevelUJ2)*100;
   double LevelEG =(LevelEG1+LevelEG2)*100;
//GJ   
//////////////////////////////////////////////////////////////     
   if (LevelGJ > MaxHGJ )
   {
      MaxHGJ = LevelGJ;
   }
 
   if (LevelGJ < MinLGJ )
   {
      MinLGJ = LevelGJ;
   }   
  
   Write("MPS_6GJ",  roh, 10, 20, " GBPJPY   New",  font, "Arial Bold", Popis );
   Write("MPS_16GJ",  roh, 350, 20, " USDJPY*GBPUSD   New",  10, "Arial Bold", Popis );
    Write("MPS_17GJ",  roh, 600, 20, " EURJPY/EURGBP   New",  10, "Arial Bold", Popis );
   Write("MPS_21GJ", roh, 10, 40, "High", font, "Arial Bold", Popis);
   Write("MPS_26GJ", roh, 10, 60, "Low",  font, "Arial Bold", Popis);
   
   if (LevelGJ > 0)
      Write("MPS_30GJ", roh, 150, 20, DoubleToStr(LevelGJ  ,Digits)+"   ", font, "Arial Bold", Plus);
   if (LevelGJ1 > 0)   
      Write("MPS_31GJ", roh, 250, 20, DoubleToStr(LevelGJ1*100  ,Digits)+"   ", 10, "Arial Bold", Plus);
     if (LevelGJ2 > 0)  
        Write("MPS_32GJ", roh, 500, 20, DoubleToStr(LevelGJ2*100  ,Digits)+"   ",10, "Arial Bold", Plus);
   if (LevelGJ < 0)
      Write("MPS_30GJ", roh, 150, 20, DoubleToStr(LevelGJ,Digits)+"   ", font, "Arial Bold", Minus);
     if (LevelGJ1 < 0) 
       Write("MPS_31GJ", roh, 250, 20, DoubleToStr(LevelGJ1*100 ,Digits)+"   ", 10, "Arial Bold", Minus); 
     if (LevelGJ2 < 0)  
        Write("MPS_32GJ", roh, 500, 20, DoubleToStr(LevelGJ2*100  ,Digits)+"   ", 10, "Arial Bold", Minus);
  
   if (LevelGJ == 0)
      Write("MPS_30GJ", roh, 150, 20, DoubleToStr(LevelGJ,Digits)+"   ", font, "Arial Bold", Popis); 
      if (LevelGJ1 == 0) 
      Write("MPS_31GJ", roh, 250, 20, DoubleToStr(LevelGJ1*100  ,Digits)+"   ", 10, "Arial Bold", Popis);
     if (LevelGJ2 == 0)   
        Write("MPS_32GJ", roh, 500, 20, DoubleToStr(LevelGJ2*100  ,Digits)+"   ", 10, "Arial Bold", Popis);
             
   Write("MPS_99GJ", roh, 150, 40, DoubleToStr(MaxHGJ,Digits) +"   ", font, "Arial Bold", Hodnota);
   Write("MPS_97GJ", roh, 150, 60, DoubleToStr(MinLGJ,Digits) +"   ", font, "Arial Bold", Hodnota); 
   
    
////////////////////////////////////////////////////////////

   double offsetY_EU = 210;
// EU   



   double offsetY_GU = 140; 
// GU   
//////////////////////////////////////////////////////////////     
   
   ////////////////////////////////////////////////////////////


   double offsetY_EJ = 70; 
// EJ 
//////////////////////////////////////////////////////////////     
   if (LevelEJ > MaxHEJ)
   {
      MaxHEJ = LevelEJ;
   }
 
   if (LevelEJ < MinLEJ )
   {
      MinLEJ = LevelEJ;
   }   
  
   
   Write("MPS_6EJ",  roh, 10, 20+offsetY_EJ, " EURJPY  New",font, "Arial Bold", Popis);
   Write("MPS_16EJ",  roh, 350, 20+offsetY_EJ, "  USDJPY*EURUSD New",10, "Arial Bold", Popis);
   Write("MPS_17EJ",  roh, 600, 20+offsetY_EJ, " GBPJPY*EURGBP  New",10, "Arial Bold", Popis);
   Write("MPS_21EJ", roh, 10, 40+offsetY_EJ, "High", font, "Arial Bold", Popis);
   Write("MPS_26EJ", roh, 10, 60+offsetY_EJ, "Low",  font, "Arial Bold", Popis);
   
   if (LevelEJ > 0)
      Write("MPS_30EJ", roh, 150, 20+offsetY_EJ, DoubleToStr(LevelEJ,Digits)+"   ", font, "Arial Bold", Plus);
     if (LevelEJ1 > 0) 
      Write("MPS_31EJ", roh, 250, 20+offsetY_EJ, DoubleToStr(LevelEJ1*100,Digits)+"   ", 10, "Arial Bold", Plus);
    if (LevelEJ2 > 0)  
      Write("MPS_32EJ", roh, 500, 20+offsetY_EJ, DoubleToStr(LevelEJ2*100,Digits)+"   ", 10, "Arial Bold", Plus); 
   if (LevelEJ < 0)
      Write("MPS_30EJ", roh, 150, 20+offsetY_EJ, DoubleToStr(LevelEJ,Digits)+"   ", font, "Arial Bold", Minus);
     if (LevelEJ1 < 0) 
      Write("MPS_31EJ", roh, 250, 20+offsetY_EJ, DoubleToStr(LevelEJ1*100,Digits)+"   ", 10, "Arial Bold", Minus);
     if (LevelEJ2 < 0) 
      Write("MPS_32EJ", roh, 500, 20+offsetY_EJ, DoubleToStr(LevelEJ2*100,Digits)+"   ", 10, "Arial Bold", Minus);   
   if (LevelEJ == 0)
      Write("MPS_30EJ", roh, 150, 20+offsetY_EJ, DoubleToStr(LevelEJ,Digits)+"   ", font, "Arial Bold", Popis); 
    if (LevelEJ1 == 0)  
      Write("MPS_31EJ", roh, 250, 20+offsetY_EJ, DoubleToStr(LevelEJ1*100,Digits)+"   ", 10, "Arial Bold", Popis);
      if (LevelEJ2 == 0)
      Write("MPS_32EJ", roh, 500, 20+offsetY_EJ, DoubleToStr(LevelEJ*100,Digits)+"   ", 10, "Arial Bold", Popis);
      
       Write("MPS_9EJ", roh, 150, 40+offsetY_EJ, DoubleToStr(MaxHEJ,Digits) +"   ", font, "Arial Bold", Hodnota);
   Write("MPS_97EJ", roh, 150, 60+offsetY_EJ, DoubleToStr(MinLEJ,Digits) +"   ", font, "Arial Bold", Hodnota);
      
   ////////////////////////////////////////////////////////////
   
    double offsetY_UJ = 140; 
// EJ 
//////////////////////////////////////////////////////////////     
   
   ////////////////////////////////////////////////////////////
   
   double offsetY_EG = 140; 
// EJ 
//////////////////////////////////////////////////////////////     
   if (LevelEG > MaxHEG)
   {
      MaxHEG = LevelEG;
   }
 
   if (LevelEG < MinLEG )
   {
      MinLEG = LevelEG;
   }   
  
    Write("MPS_6EG",  roh, 10, 20+offsetY_EG, " EURGBP  New",font, "Arial Bold", Popis);
   Write("MPS_16EG",  roh, 350, 20+offsetY_EG, "  EURUSD/GBPUSD New",10, "Arial Bold", Popis);
   Write("MPS_17EG",  roh, 600, 20+offsetY_EG, " EURJPY/GBPJPY  New",10, "Arial Bold", Popis);
   Write("MPS_21EG", roh, 10, 40+offsetY_EG, "High", font, "Arial Bold", Popis);
   Write("MPS_26EG", roh, 10, 60+offsetY_EG, "Low",  font, "Arial Bold", Popis);
   
   if (LevelEG > 0)
      Write("MPS_30EG", roh, 150, 20+offsetY_EG, DoubleToStr(LevelEG,Digits)+"   ", font, "Arial Bold", Plus);
     if (LevelEG1 > 0) 
      Write("MPS_31EG", roh, 250, 20+offsetY_EG, DoubleToStr(LevelEG1*100,Digits)+"   ", 10, "Arial Bold", Plus);
    if (LevelEG2 > 0)  
      Write("MPS_32EG", roh, 500, 20+offsetY_EG, DoubleToStr(LevelEG2*100,Digits)+"   ", 10, "Arial Bold", Plus); 
   if (LevelEG < 0)
      Write("MPS_30EG", roh, 150, 20+offsetY_EG, DoubleToStr(LevelEG,Digits)+"   ", font, "Arial Bold", Minus);
     if (LevelEG1 < 0) 
      Write("MPS_31EG", roh, 250, 20+offsetY_EG, DoubleToStr(LevelEG1*100,Digits)+"   ", 10, "Arial Bold", Minus);
     if (LevelEG2 < 0) 
      Write("MPS_32EG", roh, 500, 20+offsetY_EG, DoubleToStr(LevelEG2*100,Digits)+"   ", 10, "Arial Bold", Minus);   
   if (LevelEG == 0)
      Write("MPS_30EG", roh, 150, 20+offsetY_EG, DoubleToStr(LevelEG,Digits)+"   ", font, "Arial Bold", Popis); 
    if (LevelEG1 == 0)  
      Write("MPS_31EG", roh, 250, 20+offsetY_EG, DoubleToStr(LevelEG1*100,Digits)+"   ", 10, "Arial Bold", Popis);
      if (LevelEG2 == 0)
      Write("MPS_32EG", roh, 500, 20+offsetY_EG, DoubleToStr(LevelEG*100,Digits)+"   ", 10, "Arial Bold", Popis);
                
   Write("MPS_99EG", roh, 150, 40+offsetY_EG, DoubleToStr(MaxHEG,Digits) +"   ", font, "Arial Bold", Hodnota);
   Write("MPS_97EG", roh, 150, 60+offsetY_EG, DoubleToStr(MinLEG,Digits) +"   ", font, "Arial Bold", Hodnota);  
   ////////////////////////////////////////////////////////////
   return(0);
}
//+------------------------------------------------------------------+
//| Write Procedure                                                  |
//+------------------------------------------------------------------+
void Write(string LBL, double side, int pos_x, int pos_y, string text, int fontsize, string fontname, 
            color Tcolor = CLR_NONE)
{
   ObjectCreate(LBL, OBJ_LABEL, 0, 0, 0);
   ObjectSet(LBL, OBJPROP_CORNER, side);
   ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
   ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
   ObjectSetText(LBL, text, fontsize, fontname, Tcolor);
}



